<template lang="pug">
  a.b-button(
    :class=`{
      [$attrs.mod !== '' ? 'b-button--' + $attrs.mod : '']: !!$attrs.mod,
      'b-button--disabled': isDisabled,
    }`
    @click="handler($event)"
  )
    slot
</template>

<script>
export default {
  name: 'ButtonField',
  props: {
    clickAction: {
      type: Function,
      default: () => null,
    },
    isDisabled: {
      type: Boolean,
      default: false,
    },
  },
  methods: {
    handler(e) {
      if (this.isDisabled) {
        e.preventDefault();
        return null;
      }

      if (typeof this.clickAction === 'function') {
        this.clickAction();
      }
    }
  }
};
</script>

<style lang="scss">
@import '@/assets/styles/additional/_variables.scss';
@import '@/blocks/button/button.scss';
</style>
